package mezz.jei.common.util;

import com.mojang.datafixers.util.Pair;
import java.util.Collection;
import java.util.List;
import java.util.Optional;
import java.util.function.Function;
import java.util.function.Supplier;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.Stream;
import net.minecraft.class_2960;
import net.minecraft.class_6862;
import net.minecraft.class_6885;

public class TagUtil {
	public static <TYPE> Collection<class_2960> getTags(Stream<class_6862<TYPE>> tags) {
		return tags.map(class_6862::comp_327)
			.collect(Collectors.toUnmodifiableSet());
	}

	public static <VALUE, STACK> Optional<class_2960> getTagEquivalent(
		Collection<STACK> stacks,
		Function<STACK, VALUE> stackToValue,
		Supplier<Stream<Pair<class_6862<VALUE>, class_6885.class_6888<VALUE>>>> tagSupplier
	) {
		if (stacks.size() < 2) {
			return Optional.empty();
		}

		List<VALUE> values = stacks.stream()
			.map(stackToValue)
			.toList();

		return tagSupplier.get()
			.filter(e -> {
				class_6885.class_6888<VALUE> tag = e.getSecond();
				int count = tag.method_40247();
				if (count == values.size()) {
					return IntStream.range(0, count).allMatch(i -> {
						VALUE tagValue = tag.method_40240(i).comp_349();
						VALUE value = values.get(i);
						return value.equals(tagValue);
					});
				}
				return false;
			})
			.map(e -> e.getFirst().comp_327())
			.findFirst();
	}
}
